import casadi as ca
import cstr

# Get the ODE model
f = cstr.ode()

# Get steady-state
xs, us, ds = cstr.steady_state()

# Get bounds
umin, umax = cstr.control_bounds()

[xdots] = f([xs, ca.vertcat((us,ds))])
print xdots

# Discrete time dynamics
F = ca.simpleRK(f, 100)
F.init()

Delta = 1.
[x_next] = F([xs, ca.vertcat((us,ds)), Delta])
print 'xs = ', xs
print 'xs_next = ', x_next

# Task 6.3
A_fcn = F.jacobian(0, 0) # Jacobian of x_next w.r.t. x
A_fcn.init()
B_fcn = F.jacobian(1, 0) # Jacobian of x_next w.r.t. u
B_fcn.init()

[A, _] = A_fcn([xs, ca.vertcat((us,ds)), Delta])
[B, _] = B_fcn([xs, ca.vertcat((us,ds)), Delta])

Bp = B[:,-1]
B = B[:,:-1]

print 'A = ', A
print 'B = ', B
print 'Bp = ', Bp

#
